#include "Currents.h"

typedef COM current[4];

COM cdot(current j1, current j2)
{
  return j1[0]*j2[0]-j1[1]*j2[1]-j1[2]*j2[2]-j1[3]*j2[3];
}

void cmult(COM factor, current j1, current &cur)
{
  cur[0]=factor*j1[0];
  cur[1]=factor*j1[1];
  cur[2]=factor*j1[2];
  cur[3]=factor*j1[3];
}

void cadd(current j1, current j2, current j3, current j4, current j5, current &sum)
{
  sum[0]=j1[0]+j2[0]+j3[0]+j4[0]+j5[0];
  sum[1]=j1[1]+j2[1]+j3[1]+j4[1]+j5[1];
  sum[2]=j1[2]+j2[2]+j3[2]+j4[2]+j5[2];
  sum[3]=j1[3]+j2[3]+j3[3]+j4[3]+j5[3];
}

void cadd(current j1, current j2, current j3, current &sum)
{
  sum[0]=j1[0]+j2[0]+j3[0];
  sum[1]=j1[1]+j2[1]+j3[1];
  sum[2]=j1[2]+j2[2]+j3[2];
  sum[3]=j1[3]+j2[3]+j3[3];
}

// static matrix<COM> gamma0(4,4),gamma1(4,4),gamma2(4,4),gamma3(4,4), gamma0x1(4,4),gamma0x2(4,4),gamma0x3(4,4), metric(4,4);

// void Setup_Currents(void)
// {
//   // Must now start by zero-ing all components
//   for (int i=0;i<4;i++)
//     for (int j=0;j<4;j++) {
//       gamma0 (i,j) =0.;
//       gamma0x1 (i,j) =0.;
//       gamma0x2 (i,j) =0.;
//       gamma0x3 (i,j) =0.;
//       gamma1 (i,j) =0.;
//       gamma2 (i,j) =0.;
//       gamma3 (i,j) =0.;
//       metric (i,j) =0.;
//     }

//   gamma0 (0,2)=1; // Row, then column !
//   gamma0 (1,3)=1;
//   gamma0 (2,0)=1;
//   gamma0 (3,1)=1;

//   gamma1 (0,3)=-1; // Row, then column !
//   gamma1 (1,2)=-1; 
//   gamma1 (2,1)=1;
//   gamma1 (3,0)=1;

//   gamma2 (0,3) = COM(0,1); // Row, then column !
//   gamma2 (1,2) = -COM(0,1);
//   gamma2 (2,1) = -COM(0,1);
//   gamma2 (3,0) = COM(0,1);
  
//   gamma3 (0,2) = -1;
//   gamma3 (1,3) = 1;
//   gamma3 (2,0) = 1;
//   gamma3 (3,1) = -1;

//   gamma0x1 (0,1)=1; // gamma0*gamma1
//   gamma0x1 (1,0)=1; 
//   gamma0x1 (2,3)=-1;
//   gamma0x1 (3,2)=-1;

//   gamma0x2 (0,1) = -COM(0,1); // gamma0*gamma2
//   gamma0x2 (1,0) = COM(0,1);
//   gamma0x2 (2,3) = COM(0,1);
//   gamma0x2 (3,2) = -COM(0,1);
  
//   gamma0x3 (0,0) = 1;      // gamma0*gamma3
//   gamma0x3 (1,1) = -1;
//   gamma0x3 (2,2) = -1;
//   gamma0x3 (3,3) = 1;

//   metric (0,0) = 1;
//   metric (1,1) = -1;
//   metric (2,2) = -1;
//   metric (3,3) = -1;

//   std::cout<< "# Currents::Currents Initialised\n" <<std::endl;
// }

double abs2(COM a)
{
  return (a*conj(a)).real();
}

// matrix<COM> SpinorOut (CLHEP::HepLorentzVector p, bool hel)
// {
//   matrix<COM> spinor (4,1);
  
//   COM pperp=p.x()+COM(0,1)*p.y();
  
//   if (hel==true) { // spin "up" or heliticy +1;
//     spinor(0,0) = sqrt(p.plus());
//     spinor(1,0) = sqrt(p.minus()) * pperp/abs(pperp);
//     spinor(2,0) = 0.;
//     spinor(3,0) = 0.;
//   } else {
//     spinor(0,0) = 0.;
//     spinor(1,0) = 0.;
//     spinor(2,0) = sqrt(p.minus()) * conj(pperp)/abs(pperp);
//     spinor(3,0) = - sqrt(p.plus());
//   }

//   return spinor;
// }

// matrix<COM> SpinorP (CLHEP::HepLorentzVector p, bool hel)
// {
//   matrix<COM> spinor (4,1);

//   if (hel==true) { // spin "up" or heliticy +1;
//     spinor(0,0) = sqrt(p.plus());
//     spinor(1,0) = 0.;
//     spinor(2,0) = 0.;
//     spinor(3,0) = 0.;
//   } else {
//     spinor(3,0) = -sqrt(p.plus());
//     spinor(1,0) = 0.;
//     spinor(2,0) = 0.;
//     spinor(0,0) = 0.;
//   }
//   return spinor;
// }

// matrix<COM> SpinorM (CLHEP::HepLorentzVector p, bool hel)
// {
//   matrix<COM> spinor (4,1);

//   if (hel==true) { // spin "up" or heliticy +1;
//     spinor(1,0) = -sqrt(p.minus());
//     spinor(0,0) = 0.;
//     spinor(2,0) = 0.;
//     spinor(3,0) = 0.;
//   } else {
//     spinor(2,0) = -sqrt(p.minus());
//     spinor(0,0) = 0.;
//     spinor(1,0) = 0.;
//     spinor(3,0) = 0.;
//   }
//   return spinor;
// }

// matrix<COM> SpinorIn (CLHEP::HepLorentzVector p, bool hel)
// {
//   matrix<COM> spinor (4,1);

//   if (p.plus()>p.minus())
//     return SpinorP(p,hel);
//   else
//     return SpinorM(p,hel);
// }

// matrix<COM> Bar(matrix<COM> spinor)
// {
//   return prod (herm(spinor),gamma0);
// }

// matrix<COM> Current (CLHEP::HepLorentzVector pout, bool helout, CLHEP::HepLorentzVector pin, bool helin)
// {
//   matrix<COM> bsp1(1,4);
//   matrix<COM> sp2(4,1);
//   matrix<COM> cur(4,1);
//   matrix<COM> temp(1,4),temp2(1,1);
  
//   bsp1=herm(SpinorOut(pout,helout));
//   sp2=SpinorIn(pin,helin);

//   noalias(temp2)=prod(bsp1,sp2);   // as gamma0^2=Id
//   COM comp1=temp2(0,0);
  
//   noalias(temp)=prod(bsp1,gamma0x1);
//   noalias(temp2)=prod(temp,sp2);
//   COM comp2=temp2(0,0);

//   noalias(temp)=prod(bsp1,gamma0x2);
//   noalias(temp2)=prod(temp,sp2);
//   COM comp3=temp2(0,0);

//   noalias(temp)=prod(bsp1,gamma0x3);
//   noalias(temp2)=prod(temp,sp2);
//   COM comp4=temp2(0,0);

//   cur(0,0)=comp1;
//   cur(1,0)=comp2;
//   cur(2,0)=comp3;
//   cur(3,0)=comp4;

// //   std::cout<< "Current:\n";
// //   std::cout<< " bsp1 : "<<bsp1<<std::endl;
// //   std::cout<< " sp2 : "<<sp2<<std::endl;
// //   std::cout<< " cur : "<<cur<<std::endl;
//   return cur;
// }

void j (CLHEP::HepLorentzVector pout, bool helout, CLHEP::HepLorentzVector pin, bool helin,current &cur)
{
  
  cur[0]=0.;
  cur[1]=0.;
  cur[2]=0.;
  cur[3]=0.;
  
  double sqpop=sqrt(pout.plus());
  double sqpom=sqrt(pout.minus());
  COM poperp=pout.x()+COM(0,1)*pout.y();
  
  if (helout!=helin) {
    std::cerr<< "void j : Non-matching helicities\n";
  } else if (helout==false) { // negative helicity
    if (pin.plus()>pin.minus()) { // if forward
      double sqpip=sqrt(pin.plus());
      cur[0]=sqpop*sqpip;
      cur[1]=sqpom*sqpip*poperp/abs(poperp);
      cur[2]=-COM(0,1)*cur[1];
      cur[3]=cur[0];
    } else { // if backward
      double sqpim=sqrt(pin.minus());
      cur[0]=-sqpom*sqpim*poperp/abs(poperp);
      cur[1]=-sqpim*sqpop;
      cur[2]=COM(0,1)*cur[1];
      cur[3]=-cur[0];
    } 
  } else { // positive helicity
    if (pin.plus()>pin.minus()) { // if forward
      double sqpip=sqrt(pin.plus());
      cur[0]=sqpop*sqpip;
      cur[1]=sqpom*sqpip*conj(poperp)/abs(poperp);
      cur[2]=COM(0,1)*cur[1];
      cur[3]=cur[0];
    } else { // if backward
      double sqpim=sqrt(pin.minus());
      cur[0]=-sqpom*sqpim*conj(poperp)/abs(poperp);
      cur[1]=-sqpim*sqpop;
      cur[2]=-COM(0,1)*cur[1];
      cur[3]=-cur[0];
    } 
  }
}

void jio (CLHEP::HepLorentzVector pin, bool helin, CLHEP::HepLorentzVector pout, bool helout,current &cur)
{
  
  cur[0]=0.;
  cur[1]=0.;
  cur[2]=0.;
  cur[3]=0.;
  
  double sqpop=sqrt(pout.plus());
  double sqpom=sqrt(pout.minus());
  COM poperp=pout.x()+COM(0,1)*pout.y();
  
  if (helout!=helin) {
    std::cerr<< "void j : Non-matching helicities\n";
  } else if (helout==false) { // negative helicity
    if (pin.plus()>pin.minus()) { // if forward
      double sqpip=sqrt(pin.plus());
      cur[0]=sqpop*sqpip;
      cur[1]=sqpom*sqpip*conj(poperp)/abs(poperp);
      cur[2]=COM(0,1)*cur[1];
      cur[3]=cur[0];
    } else { // if backward
      double sqpim=sqrt(pin.minus());
      cur[0]=-sqpom*sqpim*conj(poperp)/abs(poperp);
      cur[1]=-sqpim*sqpop;
      cur[2]=-COM(0,1)*cur[1];
      cur[3]=-cur[0];
    } 
  } else { // positive helicity
    if (pin.plus()>pin.minus()) { // if forward
      double sqpip=sqrt(pin.plus());
      cur[0]=sqpop*sqpip;
      cur[1]=sqpom*sqpip*poperp/abs(poperp);
      cur[2]=-COM(0,1)*cur[1];
      cur[3]=cur[0];
    } else { // if backward
      double sqpim=sqrt(pin.minus());
      cur[0]=-sqpom*sqpim*poperp/abs(poperp);
      cur[1]=-sqpim*sqpop;
      cur[2]=COM(0,1)*cur[1];
      cur[3]=-cur[0];
    } 
  }
}

// matrix<COM> CurrentOutOut (CLHEP::HepLorentzVector pout, bool helout, CLHEP::HepLorentzVector pout2, bool helout2)
// {
//   matrix<COM> bsp1(1,4);
//   matrix<COM> sp2(4,1);
//   matrix<COM> cur(4,1);
//   matrix<COM> temp(1,4),temp2(1,1);
  
//   bsp1=herm(SpinorOut(pout,helout));
//   sp2=SpinorOut(pout2,helout2);

//   noalias(temp2)=prod(bsp1,sp2);   // as gamma0^2=Id
//   COM comp1=temp2(0,0);
  
//   noalias(temp)=prod(bsp1,gamma0x1);
//   noalias(temp2)=prod(temp,sp2);
//   COM comp2=temp2(0,0);

//   noalias(temp)=prod(bsp1,gamma0x2);
//   noalias(temp2)=prod(temp,sp2);
//   COM comp3=temp2(0,0);

//   noalias(temp)=prod(bsp1,gamma0x3);
//   noalias(temp2)=prod(temp,sp2);
//   COM comp4=temp2(0,0);

//   cur(0,0)=comp1;
//   cur(1,0)=comp2;
//   cur(2,0)=comp3;
//   cur(3,0)=comp4;

//   //   std::cout<< "Current:\n";
//    //   std::cout<< " bsp1 : "<<bsp1<<std::endl;
//    //   std::cout<< " sp2 : "<<sp2<<std::endl;
//   //   std::cout<< " cur : "<<cur<<std::endl;
//   return cur;
// }

void joo (CLHEP::HepLorentzVector pi, bool heli, CLHEP::HepLorentzVector pj, bool helj, current &cur)
{
 
  if (heli!=helj) {
    std::cerr<< "void j : Non-matching helicities\n";
  } else if (heli==true) { // negative helicity
    CLHEP::HepLorentzVector dummy;
    dummy=pi;
    pi=pj;
    pj=dummy;
  }
  double sqpjp=sqrt(pj.plus());
  double sqpjm=sqrt(pj.minus());
  double sqpip=sqrt(pi.plus());
  double sqpim=sqrt(pi.minus());
  COM piperp=pi.x()+COM(0,1)*pi.y();
  COM pjperp=pj.x()+COM(0,1)*pj.y();
  COM phasei=piperp/abs(piperp);
  COM phasej=pjperp/abs(pjperp);

  cur[0]=sqpim*sqpjm*phasei*conj(phasej)+sqpip*sqpjp;
  cur[1]=sqpim*sqpjp*phasei+sqpip*sqpjm*conj(phasej);
  cur[2]=-COM(0,1)*(sqpim*sqpjp*phasei-sqpip*sqpjm*conj(phasej));
  cur[3]=-sqpim*sqpjm*phasei*conj(phasej)+sqpip*sqpjp;
}

// COM Brac3(matrix<COM> cur, CLHEP::HepLorentzVector pmid)
// {
//   COM dottedcurrent = pmid.e()*cur(0,0) - pmid.x()*cur(1,0) - pmid.y()*cur(2,0) - pmid.z()*cur(3,0);
//   //  std::cout<<"pmid: "<<pmid<<"  cur: "<<cur<<std::endl;
//   //  std::cout<<"gives: "<<dottedcurrent<<std::endl;
//   return dottedcurrent;
// }

// double M2 (CLHEP::HepLorentzVector p1out, bool hel1out, CLHEP::HepLorentzVector p1in, bool hel1in, CLHEP::HepLorentzVector p2out, bool hel2out, CLHEP::HepLorentzVector p2in, bool hel2in)
// {
//   CLHEP::HepLorentzVector q1=p1in-p1out;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);
//   matrix<COM> C1 =Current(p1out,hel1out,p1in,hel1in);
//   matrix<COM> C2 =Current(p2out,hel2out,p2in,hel2in);
//   matrix<COM> q1v (4,1),q2v(4,1);
// //   std::cout << "# From Currents, p1out : "<<p1out<<"\n";
// //   std::cout << "# From Currents, hel1out : "<<hel1out<<"\n";
// //   std::cout << "# From Currents, p1in : "<<p1in<<"\n";
// //   std::cout << "# From Currents, hel1in : "<<hel1in<<"\n";
//   std::cout << "# From Currents, C1 : "<<C1<<"\n";
//   std::cout << "# From Currents, C2 : "<<C2<<"\n";
  
//   q1v(0,0)=q1.e();
//   q1v(1,0)=q1.x();
//   q1v(2,0)=q1.y();
//   q1v(3,0)=q1.z();

//   q2v(0,0)=q2.e();
//   q2v(1,0)=q2.x();
//   q2v(2,0)=q2.y();
//   q2v(3,0)=q2.z();

//   matrix<COM> temp (1,4),temp2(1,1);
  
//   // C1.C2 
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp2)=prod(temp,C2);
  
//   COM M=temp2(0,0);

// //   std::cout<<"# From Currents : "<<(M*conj(M)).real()/(q1.m2()*q2.m2())<<"\n";
//   return (M*conj(M)).real()/(q1.m2()*q2.m2());
// }

double jM2 (CLHEP::HepLorentzVector p1out, bool hel1out, CLHEP::HepLorentzVector p1in, bool hel1in, CLHEP::HepLorentzVector p2out, bool hel2out, CLHEP::HepLorentzVector p2in, bool hel2in)
{
  CLHEP::HepLorentzVector q1=p1in-p1out;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current C1,C2;
  j (p1out,hel1out,p1in,hel1in, C1);
  j (p2out,hel2out,p2in,hel2in, C2);
  
  std::cout << "# From Currents, C1 : ("<<C1[0]<<","<<C1[1]<<","<<C1[2]<<","<<C1[3]<<"\n";
  std::cout << "# From Currents, C2 : ("<<C2[0]<<","<<C2[1]<<","<<C2[2]<<","<<C2[3]<<"\n";

  COM M=cdot(C1,C2);

//   std::cout<<"# From Currents : "<<(M*conj(M)).real()/(q1.m2()*q2.m2())<<"\n";
  return (M*conj(M)).real()/(q1.m2()*q2.m2());
}

// double MH2 (CLHEP::HepLorentzVector p1out, bool hel1out, CLHEP::HepLorentzVector p1in, bool hel1in, CLHEP::HepLorentzVector p2out, bool hel2out, CLHEP::HepLorentzVector p2in, bool hel2in)
// {
//   CLHEP::HepLorentzVector q1=p1in-p1out;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);
//   matrix<COM> C1 =Current(p1out,hel1out,p1in,hel1in);
//   matrix<COM> C2 =Current(p2out,hel2out,p2in,hel2in);
//   matrix<COM> q1v (4,1),q2v(4,1);
  
//   q1v(0,0)=q1.e();
//   q1v(1,0)=q1.x();
//   q1v(2,0)=q1.y();
//   q1v(3,0)=q1.z();

//   q2v(0,0)=q2.e();
//   q2v(1,0)=q2.x();
//   q2v(2,0)=q2.y();
//   q2v(3,0)=q2.z();

//   matrix<COM> temp (1,4),temp2(1,1);
// //   std::cout<< "MH2:\n";
// //   std::cout<< " C1 : "<<C1<<"\n";
// //   std::cout<< " C2 : "<<C2<<"\n";
//   // First the C1.q2 * C2.q1 - part
//   noalias(temp)=prod(trans(C1),metric);
// //   std::cout<< " temp : "<<temp<<"\n";
//   noalias(temp2)=prod(temp,q2v);
  
//   COM prod1=temp2(0,0);
// //   std::cout<< " prod1 : "<<prod1<<"\n";

//   noalias(temp)=prod(trans(C2),metric);
//   noalias(temp2)=prod(temp,q1v);
  
//   COM prod2=temp2(0,0);

//   COM M1=prod1*prod2;
  
//   // Then the C1.C2 * q1.q2
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp2)=prod(temp,C2);
  
//   prod1=temp2(0,0);

//   prod2=-q1.dot(q2);

//   COM M2=prod1*prod2;

//   COM M=(M1+M2)/(q1.m2()*q2.m2());
//   return (M*conj(M)).real();
// }

// matrix<COM> WCurrentNew (CLHEP::HepLorentzVector pout, bool helout, CLHEP::HepLorentzVector pe, bool hele, CLHEP::HepLorentzVector pnu, bool helnu, CLHEP::HepLorentzVector pin, bool helin)
// {
//   // NOTA BENE: Conventions for W+ --> e+ nu, so that nu is lepton(6), e is anti-lepton(5)
//   // Need to swap e and nu for events with W- --> e- nubar!
//   matrix<COM> cur(4,1);
//   if (helin==helout && hele==helnu) {
//     CLHEP::HepLorentzVector qa=pout+pe+pnu;
//     CLHEP::HepLorentzVector qb=pin-pe-pnu;
//     matrix<COM> alpha15(4,1),alpha16(4,1),alpha54(4,1),alpha64(4,1);
//     double ta(qa.m2()),tb(qb.m2());
    
//     matrix<COM> ctemp(4,1),temp(1,4),temp2(1,1);
    
//     noalias(ctemp)=CurrentOutOut(pnu,helnu,pe,hele);
//     //    std::cout<<"ctemp: "<<ctemp<<" pe: "<<pe<<" pnu: "<<pnu<<std::endl;
//     COM brac615=Brac3(ctemp,pout);
//     COM brac645=Brac3(ctemp,pin);
    
//     noalias(temp)=prod(trans(CurrentOutOut(pout,helout,pe,helout)),metric);
//     noalias(temp2)=prod(temp,ctemp);
//     COM prod1565=temp2(0,0);
//     noalias(temp)=prod(trans(CurrentOutOut(pout,helout,pnu,helout)),metric);
//     noalias(temp2)=prod(temp,ctemp);
//     COM prod1665=temp2(0,0);
//     noalias(temp)=prod(trans(Current(pe,helin,pin,helin)),metric);
//     noalias(temp2)=prod(temp,ctemp);
//     COM prod5465=temp2(0,0);
//     noalias(temp)=prod(trans(Current(pnu,helin,pin,helin)),metric);
//     noalias(temp2)=prod(temp,ctemp);
//     COM prod6465=temp2(0,0);

//     //    std::cout<<brac615<<"  "<<brac645<<"  "<<prod1565<<"  "<<prod1665<<"  "<<prod5465<<"  "<<prod6465<<std::endl;
//     cur=((2.*brac615*Current(pout,helout,pin,helin)+prod1565*Current(pe,helin,pin,helin)+prod1665*Current(pnu,helin,pin,helin))/ta + (2.*brac645*Current(pout,helout,pin,helin)-prod5465*CurrentOutOut(pout,helout,pe,helout)-prod6465*CurrentOutOut(pout,helout,pnu,helout))/tb);
//   }
//   else {
//     std::cout<<"this? "<<std::endl;
//     cur(0,0)=0.;
//     cur(1,0)=0.;
//     cur(2,0)=0.;
//     cur(3,0)=0.;
//   }
//     return cur;
// }

void jW (CLHEP::HepLorentzVector pout, bool helout, CLHEP::HepLorentzVector pe, bool hele, CLHEP::HepLorentzVector pnu, bool helnu, CLHEP::HepLorentzVector pin, bool helin, current cur)
{
  // NOTA BENE: Conventions for W+ --> e+ nu, so that nu is lepton(6), e is anti-lepton(5)
  // Need to swap e and nu for events with W- --> e- nubar!
  if (helin==helout && hele==helnu) {
    CLHEP::HepLorentzVector qa=pout+pe+pnu;
    CLHEP::HepLorentzVector qb=pin-pe-pnu;
    double ta(qa.m2()),tb(qb.m2());
    
    current t65,vout,vin,temp2,temp3,temp5;
    joo(pnu,helnu,pe,hele,t65);
    vout[0]=pout.e();
    vout[1]=pout.x();
    vout[2]=pout.y();
    vout[3]=pout.z();
    vin[0]=pin.e();
    vin[1]=pin.x();
    vin[2]=pin.y();
    vin[3]=pin.z();
    
    COM brac615=cdot(t65,vout);
    COM brac645=cdot(t65,vin);
    
    // prod1565 and prod6465 are zero for Ws (not Zs)!!
    // noalias(temp)=prod(trans(CurrentOutOut(pout,helout,pnu,helout)),metric);
    joo(pout,helout,pnu,helout,temp2);
    // noalias(temp2)=prod(temp,ctemp);
    COM prod1665=cdot(temp2,t65);
    // noalias(temp)=prod(trans(Current(pe,helin,pin,helin)),metric);
    // noalias(temp2)=prod(temp,ctemp);
    j(pe,helin,pin,helin,temp3);
    COM prod5465=cdot(temp3,t65);
    // noalias(temp)=prod(trans(Current(pnu,helin,pin,helin)),metric);
    // noalias(temp2)=prod(temp,ctemp);

    joo(pout,helout,pe,helout,temp2);
    j(pnu,helnu,pin,helin,temp3);
    j(pout,helout,pin,helin,temp5);

    current term1,term2,term3,sum;
    cmult(2.*brac615/ta+2.*brac645/tb,temp5,term1);
    cmult(prod1665/ta,temp3,term2);
    cmult(-prod5465/tb,temp2,term3);

   //    cur=((2.*brac615*Current(pout,helout,pin,helin)+prod1565*Current(pe,helin,pin,helin)+prod1665*Current(pnu,helin,pin,helin))/ta + (2.*brac645*Current(pout,helout,pin,helin)-prod5465*CurrentOutOut(pout,helout,pe,helout)-prod6465*CurrentOutOut(pout,helout,pnu,helout))/tb);
    //    cur=((2.*brac615*temp5+prod1565*temp3+prod1665*temp4)/ta + (2.*brac645*temp5-prod5465*temp1-prod6465*temp2)/tb);
    cadd(term1,term2,term3,sum);
    //    std::cout<<"sum: ("<<sum[0]<<","<<sum[1]<<","<<sum[2]<<","<<sum[3]<<")\n";
    cur[0]=sum[0];
    cur[1]=sum[1];
    cur[2]=sum[2];
    cur[3]=sum[3];
  }
}

void jWbar (CLHEP::HepLorentzVector pout, bool helout, CLHEP::HepLorentzVector pe, bool hele, CLHEP::HepLorentzVector pnu, bool helnu, CLHEP::HepLorentzVector pin, bool helin, current cur)
{
  // NOTA BENE: Conventions for W+ --> e+ nu, so that nu is lepton(6), e is anti-lepton(5)
  // Need to swap e and nu for events with W- --> e- nubar!
  if (helin==helout && hele==helnu) {
    CLHEP::HepLorentzVector qa=pout+pe+pnu;
    CLHEP::HepLorentzVector qb=pin-pe-pnu;
    double ta(qa.m2()),tb(qb.m2());
    
    current t65,vout,vin,temp2,temp3,temp5;
    joo(pnu,helnu,pe,hele,t65);
    vout[0]=pout.e();
    vout[1]=pout.x();
    vout[2]=pout.y();
    vout[3]=pout.z();
    vin[0]=pin.e();
    vin[1]=pin.x();
    vin[2]=pin.y();
    vin[3]=pin.z();
    
    COM brac615=cdot(t65,vout);
    COM brac645=cdot(t65,vin);
    
    // prod1565 and prod6465 are zero for Ws (not Zs)!!
    joo(pe,helout,pout,helout,temp2);  //  temp2 is <5|alpha|1>
    COM prod5165=cdot(temp2,t65);
    jio(pin,helin,pnu,helin,temp3);      // temp3 is <4|alpha|6>
    COM prod4665=cdot(temp3,t65);

    joo(pnu,helout,pout,helout,temp2);  // temp2 is now <6|mu|1>
    jio(pin,helin,pe,helin,temp3);        // temp3 is now <4|mu|5>
    jio(pin,helin,pout,helout,temp5);     //  temp5 is <4|mu|1>

    current term1,term2,term3,sum;
    cmult(-2.*brac615/ta-2.*brac645/tb,temp5,term1);
    cmult(-prod5165/ta,temp3,term2);
    cmult(prod4665/tb,temp2,term3);

   //    cur=((2.*brac615*Current(pout,helout,pin,helin)+prod1565*Current(pe,helin,pin,helin)+prod1665*Current(pnu,helin,pin,helin))/ta + (2.*brac645*Current(pout,helout,pin,helin)-prod5465*CurrentOutOut(pout,helout,pe,helout)-prod6465*CurrentOutOut(pout,helout,pnu,helout))/tb);
    //    cur=((2.*brac615*temp5+prod1565*temp3+prod1665*temp4)/ta + (2.*brac645*temp5-prod5465*temp1-prod6465*temp2)/tb);
    cadd(term1,term2,term3,sum);
    //    std::cout<<"term1: ("<<temp5[0]<<"  "<<temp5[1]<<"  "<<temp5[2]<<"  "<<temp5[3]<<")"<<std::endl;
    //    std::cout<<"sum: ("<<sum[0]<<","<<sum[1]<<","<<sum[2]<<","<<sum[3]<<")\n";
    cur[0]=sum[0];
    cur[1]=sum[1];
    cur[2]=sum[2];
    cur[3]=sum[3];
  }
}

// double MW2 (CLHEP::HepLorentzVector p1out, bool hel1out, CLHEP::HepLorentzVector pe, bool hele, CLHEP::HepLorentzVector pnu, bool helnu, CLHEP::HepLorentzVector p1in, bool hel1in, CLHEP::HepLorentzVector p2out, bool hel2out, CLHEP::HepLorentzVector p2in, bool hel2in)
// {
//   CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);
//   //  std::cout<<"q1: "<<q1<<"  q2: "<<q2<<std::endl;
//   matrix<COM> C1 =WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in); // for W+
//   matrix<COM> C2 =Current(p2out,hel2out,p2in,hel2in);
//   matrix<COM> temp (1,4),temp2(1,1);

//   //  std::cout<<"C1: "<<C1<<"   C2: "<<C2<<std::endl;

//   // C1.C2 
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp2)=prod(temp,C2);
  
//   COM prod1=temp2(0,0);

//   COM M2=prod1;

//   // Leave division by 't's until Tree files
//   //  COM M=(M2)/sqrt(q1.m2()*q2.m2());  // q1 = q2 here, but left general for later.
//   COM M=(M2);  // q1 = q2 here, but left general for later.
//   return (M*conj(M)).real();
// }

// double MWqQ (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector pe, CLHEP::HepLorentzVector pnu,CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// // Calculates the square of the current contractions for qg->qenug scattering
// // p1: quark (with W emittance)
// // p2: Quark
// {
//   matrix<COM> temp (1,4),temp2(1,1);
//   CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);

//   matrix<COM> mj1m =WCurrentNew(p1out,false,pe,false,pnu,false,p1in,false);

//   matrix<COM> mj2p =Current(p2out,true,p2in,true);
//   matrix<COM> mj2m =Current(p2out,false,p2in,false);
  
//   // std::cout<<"MqQ: "<<mj1m<<"\n";
//   // std::cout<<mj2p<<"\n";
//   // std::cout<<mj2m<<"\n";
  
//   // mj1m.mj2p 
//   noalias(temp)=prod(trans(mj1m),metric);
//   noalias(temp2)=prod(temp,mj2p);

//   COM Mmp=temp2(0,0);

//   // mj1m.mj2m
//   noalias(temp2)=prod(temp,mj2m);
//   COM Mmm=temp2(0,0);

//   // sum of spinor strings ||^2
//   double a2Mmp=abs2(Mmp);
//   double a2Mmm=abs2(Mmm);

// //   // Leave division by colour and Helicity avg until Tree files
//   // Leave multi. of couplings to later
//   // Multiply by Cf^2
//   return (4./3.)*(4./3.)*(a2Mmp+a2Mmm)/(q1.m2()*q2.m2());

// }

double jMWqQ (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector pe, CLHEP::HepLorentzVector pnu,CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for qQ->qenuQ scattering
// p1: quark (with W emittance)
// p2: Quark
{
  current mj1m,mj2p,mj2m;
  CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);

  jW(p1out,false,pe,false,pnu,false,p1in,false,mj1m);
  j(p2out,true,p2in,true,mj2p);
  j(p2out,false,p2in,false,mj2m);
  
  // std::cout<<"jMW1: ("<<mj1m[0]<<","<<mj1m[1]<<","<<mj1m[2]<<","<<mj1m[3]<<")\n";
  // std::cout<<"jMW2: ("<<mj2p[0]<<","<<mj2p[1]<<","<<mj2p[2]<<","<<mj2p[3]<<")\n";
  // std::cout<<"jMW3: ("<<mj2m[0]<<","<<mj2m[1]<<","<<mj2m[2]<<","<<mj2m[3]<<")\n";

  // mj1m.mj2p 

  COM Mmp=cdot(mj1m,mj2p);

  // mj1m.mj2m
  COM Mmm=cdot(mj1m,mj2m);

  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);

//   // Leave division by colour and Helicity avg until Tree files
  // Leave multi. of couplings to later
  // Multiply by Cf^2
  return (4./3.)*(4./3.)*(a2Mmp+a2Mmm)/(q1.m2()*q2.m2());

}

double jMWqQbar (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector pe, CLHEP::HepLorentzVector pnu,CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for qQ->qenuQ scattering
// p1: quark (with W emittance)
// p2: Quark
{
  current mj1m,mj2p,mj2m;
  CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);

  jW(p1out,false,pe,false,pnu,false,p1in,false,mj1m);
  jio(p2in,true,p2out,true,mj2p);
  jio(p2in,false,p2out,false,mj2m);
  
  // std::cout<<"jMW1: ("<<mj1m[0]<<","<<mj1m[1]<<","<<mj1m[2]<<","<<mj1m[3]<<")\n";
  // std::cout<<"jMW2: ("<<mj2p[0]<<","<<mj2p[1]<<","<<mj2p[2]<<","<<mj2p[3]<<")\n";
  // std::cout<<"jMW3: ("<<mj2m[0]<<","<<mj2m[1]<<","<<mj2m[2]<<","<<mj2m[3]<<")\n";

  // mj1m.mj2p 

  COM Mmp=cdot(mj1m,mj2p);

  // mj1m.mj2m
  COM Mmm=cdot(mj1m,mj2m);

  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);

//   // Leave division by colour and Helicity avg until Tree files
  // Leave multi. of couplings to later
  // Multiply by Cf^2
  return (4./3.)*(4./3.)*(a2Mmp+a2Mmm)/(q1.m2()*q2.m2());

}

double jMWqbarQ (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector pe, CLHEP::HepLorentzVector pnu,CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for qQ->qenuQ scattering
// p1: quark (with W emittance)
// p2: Quark
{
  current mj1m,mj2p,mj2m;
  CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);

  jWbar(p1out,false,pe,false,pnu,false,p1in,false,mj1m);
  j(p2out,true,p2in,true,mj2p);
  j(p2out,false,p2in,false,mj2m);
  
  // std::cout<<"jMW1: ("<<mj1m[0]<<","<<mj1m[1]<<","<<mj1m[2]<<","<<mj1m[3]<<")\n";
  // std::cout<<"jMW2: ("<<mj2p[0]<<","<<mj2p[1]<<","<<mj2p[2]<<","<<mj2p[3]<<")\n";
  // std::cout<<"jMW3: ("<<mj2m[0]<<","<<mj2m[1]<<","<<mj2m[2]<<","<<mj2m[3]<<")\n";

  // mj1m.mj2p 

  COM Mmp=cdot(mj1m,mj2p);

  // mj1m.mj2m
  COM Mmm=cdot(mj1m,mj2m);

  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);

//   // Leave division by colour and Helicity avg until Tree files
  // Leave multi. of couplings to later
  // Multiply by Cf^2
  return (4./3.)*(4./3.)*(a2Mmp+a2Mmm)/(q1.m2()*q2.m2());

}

double jMWqbarQbar (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector pe, CLHEP::HepLorentzVector pnu,CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for qQ->qenuQ scattering
// p1: quark (with W emittance)
// p2: Quark
{
  current mj1m,mj2p,mj2m;
  CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);

  jWbar(p1out,false,pe,false,pnu,false,p1in,false,mj1m);
  jio(p2in,true,p2out,true,mj2p);
  jio(p2in,false,p2out,false,mj2m);
  
  // std::cout<<"jMW1: ("<<mj1m[0]<<","<<mj1m[1]<<","<<mj1m[2]<<","<<mj1m[3]<<")\n";
  // std::cout<<"jMW2: ("<<mj2p[0]<<","<<mj2p[1]<<","<<mj2p[2]<<","<<mj2p[3]<<")\n";
  // std::cout<<"jMW3: ("<<mj2m[0]<<","<<mj2m[1]<<","<<mj2m[2]<<","<<mj2m[3]<<")\n";

  // mj1m.mj2p 

  COM Mmp=cdot(mj1m,mj2p);

  // mj1m.mj2m
  COM Mmm=cdot(mj1m,mj2m);

  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);

//   // Leave division by colour and Helicity avg until Tree files
  // Leave multi. of couplings to later
  // Multiply by Cf^2
  return (4./3.)*(4./3.)*(a2Mmp+a2Mmm)/(q1.m2()*q2.m2());

}

double jMWqg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector pe, CLHEP::HepLorentzVector pnu,CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for qg->qenug scattering
// p1: quark
// p2: gluon
{
  CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current mj1m,mj2p,mj2m;

  jW(p1out,false,pe,false,pnu,false,p1in,false,mj1m);

  j(p2out,true,p2in,true,mj2p);
  j(p2out,false,p2in,false,mj2m);
  
  // mj1m.mj2p 

  COM Mmp=cdot(mj1m,mj2p);

  // mj1m.mj2m
  COM Mmm=cdot(mj1m,mj2m);

  double ratio; // p2-/pb- in the notes
  // if (p2in.plus()>0) // if the gluon is the positive
  if (p2in.pz()>0.) // if the gluon is the positive
    ratio=p2out.plus()/p2in.plus();
  else // the gluon is the negative
    ratio=p2out.minus()/p2in.minus();
    

  double nonflipcolourmult=(1.-1./9.)/2.*(ratio+1./ratio)+1./9.;
  
  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);
  double sst = nonflipcolourmult*(a2Mmp+a2Mmm);
  // double sstsave=sst;

#if 0 // add flipping amplitudes?
    COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    current mj2i;

    mj2i[0]=(p2in+p2out).e();
    mj2i[1]=(p2in+p2out).x();
    mj2i[2]=(p2in+p2out).y();
    mj2i[3]=(p2in+p2out).z();

  if (p2in.minus()>0) { // if negative incoming gluon
#if 1
    // add effect of q- g- -> q- g+
  {

    // mj1m.mj2i 

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(p2perp/conj(p2perp)*Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(Mmp)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(Mmm)).real();
    
    term/=2.;
    sst+=term;
  }
    // add effect of q- g+ -> q- g-
  {

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmm*ratio+a2Mmp/ratio)+2./9.*(conj(p2perp)/p2perp*Mmm*conj(Mmp)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(Mmm)).real();
    term+=2./sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(Mmp)).real();
    
    term/=2.; // from Cf/2
    sst+=term;
  }
  
#endif  
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+

    // mj1m.mj2i 

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio)*(Mmi*conj(Mmp)).real();
    term-=2./sqrt(ratio)*(Mmi*conj(Mmm)).real();
    
    term/=2.;
    sst+=term;

    // add effect of q- g+ -> q- g-

    term=(1.-1./9.)*(a2Mmm*ratio+a2Mmp/ratio)+2./9.*(Mmm*conj(Mmp)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio)*(Mmi*conj(Mmm)).real();
    term-=2./sqrt(ratio)*(Mmi*conj(Mmp)).real();
    
    term/=2.;
    sst+=term;
  }

#endif
//   // Leave division by colour and Helicity avg until Tree files
  // Leave multi. of couplings to later
  // Multiply by Cf*Ca=4
  return 4.*sst/(q1.m2()*q2.m2());

}

double jMWqbarg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector pe, CLHEP::HepLorentzVector pnu,CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for qg->qenug scattering
// p1: quark
// p2: gluon
{
  CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current mj1m,mj2p,mj2m;

  jWbar(p1out,false,pe,false,pnu,false,p1in,false,mj1m);

  j(p2out,true,p2in,true,mj2p);
  j(p2out,false,p2in,false,mj2m);
  
  // mj1m.mj2p 

  COM Mmp=cdot(mj1m,mj2p);

  // mj1m.mj2m
  COM Mmm=cdot(mj1m,mj2m);

  double ratio; // p2-/pb- in the notes
  // if (p2in.plus()>0) // if the gluon is the positive
  if (p2in.pz()>0.) // if the gluon is the positive
    ratio=p2out.plus()/p2in.plus();
  else // the gluon is the negative
    ratio=p2out.minus()/p2in.minus();
    

  double nonflipcolourmult=(1.-1./9.)/2.*(ratio+1./ratio)+1./9.;
  
  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);
  double sst = nonflipcolourmult*(a2Mmp+a2Mmm);
  // double sstsave=sst;

#if 0 // add flipping amplitudes?
    COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    current mj2i;

    mj2i[0]=(p2in+p2out).e();
    mj2i[1]=(p2in+p2out).x();
    mj2i[2]=(p2in+p2out).y();
    mj2i[3]=(p2in+p2out).z();

  if (p2in.minus()>0) { // if negative incoming gluon
#if 1
    // add effect of q- g- -> q- g+
  {

    // mj1m.mj2i 

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(p2perp/conj(p2perp)*Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(Mmp)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term;
  }
#endif  
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+

    // mj1m.mj2i 

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio)*(Mmi*conj(Mmp)).real();
    term-=2./sqrt(ratio)*(Mmi*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term;
  }
#endif
//   // Leave division by colour and Helicity avg until Tree files
  // Leave multi. of couplings to later
  // Multiply by Cf*Ca=4
  return 4.*sst/(q1.m2()*q2.m2());

}

// double MWqg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector pe, CLHEP::HepLorentzVector pnu,CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// // Calculates the square of the current contractions for qg->qenug scattering
// // p1: quark
// // p2: gluon
// {
//   matrix<COM> temp (1,4),temp2(1,1);
//   CLHEP::HepLorentzVector q1=p1in-p1out-pe-pnu;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);

//   matrix<COM> mj1m =WCurrentNew(p1out,false,pe,false,pnu,false,p1in,false);

//   matrix<COM> mj2p =Current(p2out,true,p2in,true);
//   matrix<COM> mj2m =Current(p2out,false,p2in,false);
  
//   // mj1m.mj2p 
//   noalias(temp)=prod(trans(mj1m),metric);
//   noalias(temp2)=prod(temp,mj2p);

//   COM Mmp=temp2(0,0);

//   // mj1m.mj2m
//   noalias(temp2)=prod(temp,mj2m);
//   COM Mmm=temp2(0,0);

//   double ratio; // p2-/pb- in the notes
//   if (p2in.plus()>0) // if the gluon is the positive
//     ratio=p2out.plus()/p2in.plus();
//   else // the gluon is the negative
//     ratio=p2out.minus()/p2in.minus();
    

//   double nonflipcolourmult=(1.-1./9.)/2.*(ratio+1./ratio)+1./9.;
  
//   // sum of spinor strings ||^2
//   double a2Mmp=abs2(Mmp);
//   double a2Mmm=abs2(Mmm);
//   double sst = nonflipcolourmult*(a2Mmp+a2Mmm);
//   // double sstsave=sst;

// #if 1 // add flipping amplitudes?
//     COM p2perp=p2out.x()+COM(0,1)*p2out.y();
//     matrix<COM> mj2i (4,1);

//     mj2i(0,0)=(p2in+p2out).e();
//     mj2i(1,0)=(p2in+p2out).x();
//     mj2i(2,0)=(p2in+p2out).y();
//     mj2i(3,0)=(p2in+p2out).z();

//     // mj2i(0,0)=2.*p2in.e();
//     // mj2i(1,0)=2.*p2in.x();
//     // mj2i(2,0)=2.*p2in.y();
//     // mj2i(3,0)=2.*p2in.z();

//     // mj2i(0,0)=2.*p2out.e();
//     // mj2i(1,0)=2.*p2out.x();
//     // mj2i(2,0)=2.*p2out.y();
//     // mj2i(3,0)=2.*p2out.z();
//   if (p2in.minus()>0) { // if negative incoming gluon
// #if 1
//     // add effect of q- g- -> q- g+
//   {

//     // mj1m.mj2i 
//     noalias(temp)=prod(trans(mj1m),metric);
//     noalias(temp2)=prod(temp,mj2i);

//     COM Mmi=temp2(0,0);

//     double term;
//     term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(p2perp/conj(p2perp)*Mmp*conj(Mmm)).real();
//     term+=2.*abs2(Mmi);
//     term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(Mmp)).real();
//     term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(Mmm)).real();
    
//     // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
//     // so don't first divide and then multiply by two
//     // term/=2.;
//     sst+=term;
//   }
// #endif  
//   } else { // positive incoming gluon
//     // std::cout << "Don't do it!\n";
//     // add effect of q- g- -> q- g+

//     // mj1m.mj2i 
//     noalias(temp)=prod(trans(mj1m),metric);
//     noalias(temp2)=prod(temp,mj2i);

//     COM Mmi=temp2(0,0);

//     double term;
//     term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(Mmp*conj(Mmm)).real();
//     term+=2.*abs2(Mmi);
//     term-=2.*sqrt(ratio)*(Mmi*conj(Mmp)).real();
//     term-=2./sqrt(ratio)*(Mmi*conj(Mmm)).real();
    
//     // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
//     // so don't first divide and then multiply by two
//     // term/=2.;
//     sst+=term;
//   }
// #endif
// //   // Leave division by colour and Helicity avg until Tree files
//   // Leave multi. of couplings to later
//   // Multiply by Cf*Ca
//   return 4.*sst/(q1.m2()*q2.m2());

// }

// double MZud2 (CLHEP::HepLorentzVector p1out, bool hel1out, CLHEP::HepLorentzVector pe, bool hele, CLHEP::HepLorentzVector pnu, bool helnu, CLHEP::HepLorentzVector p1in, bool hel1in, CLHEP::HepLorentzVector p2out, bool hel2out, CLHEP::HepLorentzVector p2in, bool hel2in)
// {

//   // Need Z couplings - appearing here as Zffbar/Wffbar
//   // so that we can leave the rest of coupling definitions as they are
//   //  double stw2=0.231;      // From PDG 
//   double stw2=0.2222;         // From MG 
//   double ctw=sqrt(1.-stw2);
//   double rt2=sqrt(2.);
//   double Zul=rt2*(1./2. - 2.*stw2/3.)/ctw;
//   //  double Zul=1.;
//   double Zdl=rt2*(-1./2.+1./3.*stw2)/ctw;
//   //  double Zdl=0.;
//   double Zur=rt2*(-2.*stw2/3.)/ctw;
//   //  double Zur=0.;
//   double Zdr=rt2*(stw2/3.)/ctw;
//   //  double Zdr=0.;

// //   double Zul=-0.260607503;
// //   double Zur=0.109746534;
// //   double Zdl=0.31548077;
// //   double Zdr=-0.0548732671;

//   matrix<COM> temp (1,4),temp2(1,1),temp3(1,1);
//   COM M;
//   double tstop,tsbottom;

//   //  std::cout<<"Test new implementation:  Old="<<WCurrent(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in)<<" and New="<<WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in)<<std::endl;

//   //  Z from top quark line
//   matrix<COM> C1 =WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in); 
//   matrix<COM> C2 =Current(p2out,hel2out,p2in,hel2in);
//   // C1.C2 
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp2)=prod(temp,C2);
//   tstop=(p1out+pe+pnu-p1in).m2();

//   //  std::cout<<"2nd test: Old="<<temp2(0,0);
//   //  matrix<COM> C3 =WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in); 
//   // C1.C2 
//   //  noalias(temp)=prod(trans(C3),metric);
//   //  noalias(temp3)=prod(temp,C2);
//   //  std::cout<<" and New="<<temp2(0,0)<<std::endl;
//   //  std::cout<<((temp2(0,0)/temp3(0,0))*conj(temp2(0,0)/temp3(0,0))).real()<<" ";

//   // Now Z from bottom quark line
//   C1 =Current(p1out,hel1out,p1in,hel1in); 
//   C2 =WCurrentNew(p2out,hel2out,pe,hele,pnu,helnu,p2in,hel2in);
//   // C1.C2 
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp3)=prod(temp,C2);
//   tsbottom=(p2out+pe+pnu-p2in).m2();

//   // Combine with correct couplings before squaring
//   if (hel1out == false) {
//     if (hel2out == false)
//       M=Zul*temp2(0,0)/tstop+Zdl*temp3(0,0)/tsbottom;
//     else 
//       M=Zul*temp2(0,0)/tstop+Zdr*temp3(0,0)/tsbottom;
//   }
//   else {
//     if (hel2out == false) 
//       M=Zur*temp2(0,0)/tstop+Zdl*temp3(0,0)/tsbottom;
//     else 
//       M=Zur*temp2(0,0)/tstop+Zdr*temp3(0,0)/tsbottom;
//   }

//   //  std::cout<<"#end: "<<M<<std::endl;
//   return (M*conj(M)).real();
// }

// CLHEP::HepLorentzVector C2LipInCur(CLHEP::HepLorentzVector qav, CLHEP::HepLorentzVector qbv, CLHEP::HepLorentzVector pim, CLHEP::HepLorentzVector pip,CLHEP::HepLorentzVector pom, CLHEP::HepLorentzVector pop) // B
// {
//   CLHEP::HepLorentzVector temptrans=-(qav+qbv);
//   CLHEP::HepLorentzVector p5=qav-qbv;
// //   std::cout<<"#C2L, p2: "<<p5<<std::endl;
//   CLHEP::HepLorentzVector CL=temptrans+qav.m2()*(1./p5.dot(pip)*pip+1./p5.dot(pop)*pop)/2.-qbv.m2()*(1./p5.dot(pim)*pim+1./p5.dot(pom)*pom)/2.+(pip*(p5.dot(pim)/pip.dot(pim)+p5.dot(pom)/pip.dot(pom)) + pop*(p5.dot(pim)/pop.dot(pim)+p5.dot(pom)/pop.dot(pom)) - pim*(p5.dot(pip)/pip.dot(pim) + p5.dot(pop)/pop.dot(pim)) - pom*(p5.dot(pip)/pip.dot(pom) + p5.dot(pop)/pop.dot(pom)) )/2.;
//   //    CLHEP::HepLorentzVector CL=temptrans+qav.m2()*(1./p5.dot(pip)*pip+1./p5.dot(pop)*pop)/2.-qbv.m2()*(1./p5.dot(pim)*pim+1./p5.dot(pom)*pom)/2.+2.*(pip*(p5.dot(pim)/pip.dot(pim)) - pim*(p5.dot(pip)/pip.dot(pim) ) );
  
// #if 0
//   cout << "#Fadin pplus : "<<pip.plus()<<endl;
//   cout << "#Fadin pminus : "<<pim.minus()<<endl;
//   cout << "#Fadin pplus : "<<pop.plus()<<endl;
//   cout << "#Fadin pminus : "<<pom.minus()<<endl;
//   cout << "#Fadin qa : "<<qav<< " "<<qav.m2()<<std::endl;
//   cout << "#Fadin qb : "<<qbv<<" "<<qbv.m2()<<std::endl;
// //   cout << "#Fadin p1 : "<<p1<<endl;
// //   cout << "#Fadin p2 : "<<p2<<endl;
//   cout << "#Fadin p5 : "<<p5<<endl;
//   cout << "#Fadin Gauge Check : "<< CL.dot(p5)<<endl;
//   cout << "#Fadin C2L : "<< -CL.dot(CL)<<" "<<-CL.dot(CL)/(qav.m2()*qbv.m2())/(4./p5.perp2())<<endl;
// #endif

//   //    return -CL.dot(CL);
//     return CL;
// }

// double M2Zud3j (CLHEP::HepLorentzVector p1out, bool hel1out, CLHEP::HepLorentzVector pe, bool hele, CLHEP::HepLorentzVector pnu, bool helnu, CLHEP::HepLorentzVector p1in, bool hel1in, CLHEP::HepLorentzVector p2out, bool hel2out, CLHEP::HepLorentzVector p2in, bool hel2in)
// {

//   // Need Z couplings - appearing here as Zffbar/Wffbar
//   double stw2=0.2222;         // From MG 
//   double ctw=sqrt(1.-stw2);
//   double rt2=sqrt(2.);
//   double Zul=rt2*(1./2. - 2.*stw2/3.)/ctw;
//   //  double Zul=1.;
//   double Zdl=rt2*(-1./2.+1./3.*stw2)/ctw;
//   //  double Zdl=0.;
//   double Zur=rt2*(-2.*stw2/3.)/ctw;
//   //  double Zur=0.;
//   double Zdr=rt2*(stw2/3.)/ctw;
//   //  double Zdr=0.;

// //   double Zul=-0.260607503;
// //   double Zur=0.109746534;
// //   double Zdl=0.31548077;
// //   double Zdr=-0.0548732671;

//   matrix<COM> temp (1,4),temp2(1,1),temp3(1,1);
//   COM ctop,cbottom;
//   double tstop,tsbottom;

//   //  std::cout<<"Test new implementation:  Old="<<WCurrent(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in)<<" and New="<<WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in)<<std::endl;

//   //  Z from top quark line
//   matrix<COM> C1 =WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in); 
//   matrix<COM> C2 =Current(p2out,hel2out,p2in,hel2in);
//   // C1.C2 
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp2)=prod(temp,C2);
//   tstop=(p1out+pe+pnu-p1in).m2()*(p2out-p2in).m2();
//   CLHEP::HepLorentzVector CLtop=C2LipInCur(p1in-p1out-pe-pnu,-(p2in-p2out),p2in,p1in,p2out,p1out);


//   //  std::cout<<"2nd test: Old="<<temp2(0,0);
//   //  matrix<COM> C3 =WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in); 
//   // C1.C2 
//   //  noalias(temp)=prod(trans(C3),metric);
//   //  noalias(temp3)=prod(temp,C2);
//   //  std::cout<<" and New="<<temp2(0,0)<<std::endl;
//   //  std::cout<<((temp2(0,0)/temp3(0,0))*conj(temp2(0,0)/temp3(0,0))).real()<<" ";

//   // Now Z from bottom quark line
//   C1 =Current(p1out,hel1out,p1in,hel1in); 
//   C2 =WCurrentNew(p2out,hel2out,pe,hele,pnu,helnu,p2in,hel2in);
//   // C1.C2 
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp3)=prod(temp,C2);
//   tsbottom=(p2out+pe+pnu-p2in).m2()*(p1out-p1in).m2();
//   CLHEP::HepLorentzVector CLbottom=C2LipInCur(p1in-p1out,-(p2in-p2out-pe-pnu),p2in,p1in,p2out,p1out);

//   // Combine with correct couplings before squaring
//   if (hel1out == false) {
//     if (hel2out == false) {
//       ctop=Zul*temp2(0,0)/tstop;
//       cbottom=Zdl*temp3(0,0)/tsbottom;
//     }
//     else {
//       ctop=Zul*temp2(0,0)/tstop;
//       cbottom=Zdr*temp3(0,0)/tsbottom;
//     }
//   }
//   else {
//     if (hel2out == false) {
//       ctop=Zur*temp2(0,0)/tstop;
//       cbottom=Zdl*temp3(0,0)/tsbottom;
//     }
//     else {
//       ctop=Zur*temp2(0,0)/tstop;
//       cbottom=Zdr*temp3(0,0)/tsbottom;
//     }
//   }

  
//   //  std::cout<<"#end: "<<M<<std::endl;
//   return (-ctop*conj(ctop)*CLtop.dot(CLtop)-cbottom*conj(cbottom)*CLbottom.dot(CLbottom)-(ctop*conj(cbottom)+conj(ctop)*cbottom)*CLtop.dot(CLbottom)).real();
// }

// double M2Zud4j (CLHEP::HepLorentzVector p1out, bool hel1out, CLHEP::HepLorentzVector pe, bool hele, CLHEP::HepLorentzVector pnu, bool helnu, CLHEP::HepLorentzVector p1in, bool hel1in, CLHEP::HepLorentzVector p2out, bool hel2out, CLHEP::HepLorentzVector p2in, bool hel2in, CLHEP::HepLorentzVector p6)
// {

//   // Need Z couplings - appearing here as Zffbar/Wffbar
//   double stw2=0.2222;         // From MG 
//   double ctw=sqrt(1.-stw2);
//   double rt2=sqrt(2.);
//   double Zul=rt2*(1./2. - 2.*stw2/3.)/ctw;
//   //  double Zul=1.;
//   double Zdl=rt2*(-1./2.+1./3.*stw2)/ctw;
//   //  double Zdl=0.;
//   double Zur=rt2*(-2.*stw2/3.)/ctw;
//   //  double Zur=0.;
//   double Zdr=rt2*(stw2/3.)/ctw;
//   //  double Zdr=0.;

//   matrix<COM> temp (1,4),temp2(1,1),temp3(1,1);
//   COM ctop,cbottom;
//   double tstop,tsbottom;

//   //  std::cout<<"Test new implementation:  Old="<<WCurrent(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in)<<" and New="<<WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in)<<std::endl;

//   //  Z from top quark line
//   matrix<COM> C1 =WCurrentNew(p1out,hel1out,pe,hele,pnu,helnu,p1in,hel1in); 
//   matrix<COM> C2 =Current(p2out,hel2out,p2in,hel2in);
//   // C1.C2 
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp2)=prod(temp,C2);
//   tstop=(p1out+pe+pnu-p1in).m2()*(p1out+pe+pnu+p6-p1in).m2()*(p2out-p2in).m2();
//   CLHEP::HepLorentzVector CLtop1=C2LipInCur(p1in-p1out-pe-pnu,p1in-p1out-pe-pnu-p6,p2in,p1in,p2out,p1out);
//   CLHEP::HepLorentzVector CLtop2=C2LipInCur(p1in-p1out-pe-pnu-p6,-(p2in-p2out),p2in,p1in,p2out,p1out);

//   // Now Z from bottom quark line
//   C1 =Current(p1out,hel1out,p1in,hel1in); 
//   C2 =WCurrentNew(p2out,hel2out,pe,hele,pnu,helnu,p2in,hel2in);
//   // C1.C2 
//   noalias(temp)=prod(trans(C1),metric);
//   noalias(temp3)=prod(temp,C2);
//   tsbottom=(p2out+pe+pnu-p2in).m2()*(p1out+p6-p1in).m2()*(p1out-p1in).m2();
//   CLHEP::HepLorentzVector CLbottom1=C2LipInCur(p1in-p1out,p1in-p1out-p6,p2in,p1in,p2out,p1out);
//   CLHEP::HepLorentzVector CLbottom2=C2LipInCur(p1in-p1out-p6,-(p2in-p2out-pe-pnu),p2in,p1in,p2out,p1out);

//   // Combine with correct couplings before squaring
//   if (hel1out == false) {
//     if (hel2out == false) {
//       ctop=Zul*temp2(0,0)/tstop;
//       cbottom=Zdl*temp3(0,0)/tsbottom;
//     }
//     else {
//       ctop=Zul*temp2(0,0)/tstop;
//       cbottom=Zdr*temp3(0,0)/tsbottom;
//     }
//   }
//   else {
//     if (hel2out == false) {
//       ctop=Zur*temp2(0,0)/tstop;
//       cbottom=Zdl*temp3(0,0)/tsbottom;
//     }
//     else {
//       ctop=Zur*temp2(0,0)/tstop;
//       cbottom=Zdr*temp3(0,0)/tsbottom;
//     }
//   }

//   // | ctop Clt1^mu Clt2^nu + cbottom Clb1^mu Clb2^nu |^2   Clt/b are real vectors  

//   COM dotprod = ctop*conj(ctop)*CLtop1.dot(CLtop1)*CLtop2.dot(CLtop2)+cbottom*conj(cbottom)*CLbottom1.dot(CLbottom1)*CLbottom2.dot(CLbottom2)+(ctop*conj(cbottom)+conj(ctop)*cbottom)*CLtop1.dot(CLbottom1)*CLtop2.dot(CLbottom2);
//   return dotprod.real();
// }

double jM2qQ (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
{
  //  std::cerr<<"Current: "<<p1out<<"  "<<p1in<<"  "<<p2out<<"  "<<p2in<<std::endl;

  CLHEP::HepLorentzVector q1=p1in-p1out;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);
  //  std::cerr<<"Current:  "<<q1.m2()<<"  "<<q2.m2()<<std::endl;
  current mj1m,mj1p,mj2m,mj2p;
  j(p1out,true,p1in,true,mj1p);
  j(p1out,false,p1in,false,mj1m);
  j(p2out,true,p2in,true,mj2p);
  j(p2out,false,p2in,false,mj2m);
  
  COM Mmp=cdot(mj1m,mj2p);
  COM Mmm=cdot(mj1m,mj2m);
  COM Mpp=cdot(mj1p,mj2p);
  COM Mpm=cdot(mj1p,mj2m);

  double sst=abs2(Mmm)+abs2(Mmp)+abs2(Mpp)+abs2(Mpm);

  // Multiply by Cf^2
  return (4./3.)*(4./3.)*(sst)/(q1.m2()*q2.m2());
}

double jM2qQbar (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
{
  CLHEP::HepLorentzVector q1=p1in-p1out;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current mj1m,mj1p,mj2m,mj2p;
  j(p1out,true,p1in,true,mj1p);
  j(p1out,false,p1in,false,mj1m);
  jio(p2in,true,p2out,true,mj2p);
  jio(p2in,false,p2out,false,mj2m);
  
  COM Mmp=cdot(mj1m,mj2p);
  COM Mmm=cdot(mj1m,mj2m);
  COM Mpp=cdot(mj1p,mj2p);
  COM Mpm=cdot(mj1p,mj2m);

  double sumsq=abs2(Mmm)+abs2(Mmp)+abs2(Mpp)+abs2(Mpm);

  // Multiply by Cf^2
  return (4./3.)*(4./3.)*(sumsq)/(q1.m2()*q2.m2());
}

double jM2qbarQbar (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
{
  CLHEP::HepLorentzVector q1=p1in-p1out;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current mj1m,mj1p,mj2m,mj2p;
  jio(p1in,true,p1out,true,mj1p);
  jio(p1in,false,p1out,false,mj1m);
  jio(p2in,true,p2out,true,mj2p);
  jio(p2in,false,p2out,false,mj2m);
  
  COM Mmp=cdot(mj1m,mj2p);
  COM Mmm=cdot(mj1m,mj2m);
  COM Mpp=cdot(mj1p,mj2p);
  COM Mpm=cdot(mj1p,mj2m);

  double sumsq=abs2(Mmm)+abs2(Mmp)+abs2(Mpp)+abs2(Mpm);

  // Multiply by Cf^2
  return (4./3.)*(4./3.)*(sumsq)/(q1.m2()*q2.m2());
}

double jM2qg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for qg scattering
// p1: quark
// p2: gluon
{
  CLHEP::HepLorentzVector q1=p1in-p1out;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);

  current mj1m,mj1p,mj2m,mj2p;
  j(p1out,true,p1in,true,mj1p);
  j(p1out,false,p1in,false,mj1m);
  j(p2out,true,p2in,true,mj2p);
  j(p2out,false,p2in,false,mj2m);

  COM Mmp=cdot(mj1m,mj2p);
  COM Mmm=cdot(mj1m,mj2m);
  COM Mpp=cdot(mj1p,mj2p);
  COM Mpm=cdot(mj1p,mj2m);

  double ratio; // p2-/pb- in the notes
  // if (p2in.plus()>0) // if the gluon is the positive
  if (p2in.pz()>0.) // if the gluon is the positive
    ratio=p2out.plus()/p2in.plus();
  else // the gluon is the negative
    ratio=p2out.minus()/p2in.minus();
    
  double nonflipcolourmult=(1.-1./9.)/2.*(ratio+1./ratio)+1./9.;
  
  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);
  double a2Mpp=abs2(Mpp);
  double a2Mpm=abs2(Mpm);
  double sst = nonflipcolourmult*(a2Mpp+a2Mpm+a2Mmp+a2Mmm);
  // double sstsave=sst;

#if 0 // add flipping amplitudes?
    COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    current mj2i;

    mj2i[0]=(p2in+p2out).e();
    mj2i[1]=(p2in+p2out).x();
    mj2i[2]=(p2in+p2out).y();
    mj2i[3]=(p2in+p2out).z();

  if (p2in.minus()>0) { // if negative incoming gluon
#if 1
    // add effect of q- g- -> q- g+ and q+ g+ -> q+ g-
  {

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(p2perp/conj(p2perp)*Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(Mmp)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(Mmm)).real();
    
    // term/=2.; // from Cf/2 
    sst+=term;
  }
#endif  
#if 1
    // add effect of q- g+ -> q- g- and q+ g- -> q+ g+
  {

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmm*ratio+a2Mmp/ratio)+2./9.*(conj(p2perp)/p2perp*Mmm*conj(Mmp)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(Mmm)).real();
    term+=2./sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(Mmp)).real();
    
    //    term/=2.; // from Cf/2 // taken out by having two different hel. conf.
    sst+=term;
  }
#endif  
  } else { // positive incoming gluon
    // add effect of q- g- -> q- g+ and q+ g+ -> q+ g-

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio)*(Mmi*conj(Mmp)).real();
    term-=2./sqrt(ratio)*(Mmi*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term;
    // add effect of q+ g- -> q+ g+ and q- g+ -> q- g-

    COM Mpi=cdot(mj1p,mj2i);

    term=(1.-1./9.)*(a2Mpp*ratio+a2Mpm/ratio)+2./9.*(Mpp*conj(Mpm)).real();
    term+=2.*abs2(Mpi);
    term-=2.*sqrt(ratio)*(Mpi*conj(Mpp)).real();
    term-=2./sqrt(ratio)*(Mpi*conj(Mpm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^- -> g^+
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term;
  }
#endif
   // std::cout <<"ratio: "<<sst/sstsave<<std::endl;
  // Cf*Ca=4
  return 4.*sst/(q1.m2()*q2.m2());

}

double jM2qbarg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for qg scattering
// p1: quark
// p2: gluon
{
  CLHEP::HepLorentzVector q1=p1in-p1out;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);

  current mj1m,mj1p,mj2m,mj2p;
  jio(p1in,true,p1out,true,mj1p);
  jio(p1in,false,p1out,false,mj1m);
  j(p2out,true,p2in,true,mj2p);
  j(p2out,false,p2in,false,mj2m);

  COM Mmp=cdot(mj1m,mj2p);
  COM Mmm=cdot(mj1m,mj2m);
  COM Mpp=cdot(mj1p,mj2p);
  COM Mpm=cdot(mj1p,mj2m);

  double ratio; // p2-/pb- in the notes
  // if (p2in.plus()>0) // if the gluon is the positive
  if (p2in.pz()>0.) // if the gluon is the positive
    ratio=p2out.plus()/p2in.plus();
  else // the gluon is the negative
    ratio=p2out.minus()/p2in.minus();
    
  double nonflipcolourmult=(1.-1./9.)/2.*(ratio+1./ratio)+1./9.;
  
  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);
  double a2Mpp=abs2(Mpp);
  double a2Mpm=abs2(Mpm);
  double sst = nonflipcolourmult*(a2Mpp+a2Mpm+a2Mmp+a2Mmm);
  // double sstsave=sst;

#if 0 // add flipping amplitudes?
    COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    current mj2i;

    mj2i[0]=(p2in+p2out).e();
    mj2i[1]=(p2in+p2out).x();
    mj2i[2]=(p2in+p2out).y();
    mj2i[3]=(p2in+p2out).z();

  if (p2in.minus()>0) { // if negative incoming gluon
#if 1
    // add effect of q- g- -> q- g+
  {

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(p2perp/conj(p2perp)*Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(Mmp)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term;
  }
#endif  
#if 1
  // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+
  {
    // COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    // matrix<COM> mj2i (4,1);
    
    // mj2i(0,0)=(p2in+p2out).e();
    // mj2i(1,0)=(p2in+p2out).x();
    // mj2i(2,0)=(p2in+p2out).y();
    // mj2i(3,0)=(p2in+p2out).z();

    COM Mpi=cdot(mj1p,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mpp*ratio+a2Mpm/ratio)+2./9.*(p2perp/conj(p2perp)*Mpp*conj(Mpm)).real();
    term+=2.*abs2(Mpi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mpi*conj(Mpp)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mpi*conj(Mpm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term;
  }
#endif
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+

    COM Mmi=cdot(mj1m,mj2i);

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio+a2Mmm/ratio)+2./9.*(Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio)*(Mmi*conj(Mmp)).real();
    term-=2./sqrt(ratio)*(Mmi*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term;
    // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+

    // COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    // matrix<COM> mj2i (4,1);
    
    // mj2i(0,0)=(p2in+p2out).e();
    // mj2i(1,0)=(p2in+p2out).x();
    // mj2i(2,0)=(p2in+p2out).y();
    // mj2i(3,0)=(p2in+p2out).z();

    COM Mpi=cdot(mj1p,mj2i);

    term=(1.-1./9.)*(a2Mpp*ratio+a2Mpm/ratio)+2./9.*(Mpp*conj(Mpm)).real();
    term+=2.*abs2(Mpi);
    term-=2.*sqrt(ratio)*(Mpi*conj(Mpp)).real();
    term-=2./sqrt(ratio)*(Mpi*conj(Mpm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term;
  }
#endif
   // std::cout <<"ratio: "<<sst/sstsave<<std::endl;
  // Cf*Ca=4
  return 4.*sst/(q1.m2()*q2.m2());

}

double jM2gg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in)
// Calculates the square of the current contractions for gg scattering
// p1: gluon
// p2: gluon
{
  CLHEP::HepLorentzVector q1=p1in-p1out;
  CLHEP::HepLorentzVector q2=-(p2in-p2out);

  current mj1m,mj1p,mj2m,mj2p;
  j(p1out,true,p1in,true,mj1p);
  j(p1out,false,p1in,false,mj1m);
  j(p2out,true,p2in,true,mj2p);
  j(p2out,false,p2in,false,mj2m);

  COM Mmp=cdot(mj1m,mj2p);
  COM Mmm=cdot(mj1m,mj2m);
  COM Mpp=cdot(mj1p,mj2p);
  COM Mpm=cdot(mj1p,mj2m);

  double ratio1; // p1-/pa- in the notes
  // if (p1in.plus()>1.) // if the gluon is the positive. Should have been a
  // 		      // test against 0, but 1. is better
  if (p1in.pz()>0.) // a much better test
    ratio1=p1out.plus()/p1in.plus();
  else // the gluon is the negative
    ratio1=p1out.minus()/p1in.minus();
  double nonflipcolourmult1=(1.-1./9.)/2.*(ratio1+1./ratio1)+1./9.;
  
  double ratio2; // p2-/pb- in the notes
  if (p2in.pz()>0.) // a much better test
    ratio2=p2out.plus()/p2in.plus();
  else // the gluon is the negative
    ratio2=p2out.minus()/p2in.minus();
  double nonflipcolourmult2=(1.-1./9.)/2.*(ratio2+1./ratio2)+1./9.;
  
  // sum of spinor strings ||^2
  double a2Mmp=abs2(Mmp);
  double a2Mmm=abs2(Mmm);
  double a2Mpp=abs2(Mpp);
  double a2Mpm=abs2(Mpm);
  double sst = nonflipcolourmult1*nonflipcolourmult2*(a2Mpp+a2Mpm+a2Mmp+a2Mmm);
  // double sstsave=sst;
#if 0
  // add flipping amplitudes
  COM p2perp=p2out.x()+COM(0,1)*p2out.y();

  current mj2i;

  mj2i[0]=(p2in+p2out).e();
  mj2i[1]=(p2in+p2out).x();
  mj2i[2]=(p2in+p2out).y();
  mj2i[3]=(p2in+p2out).z();

  COM p1perp=p1out.x()+COM(0,1)*p1out.y();

  current mj1i;

  mj1i[0]=(p1in+p1out).e();
  mj1i[1]=(p1in+p1out).x();
  mj1i[2]=(p1in+p1out).y();
  mj1i[3]=(p1in+p1out).z();

  COM Mpi=cdot(mj1p,mj2i);
  COM Mmi=cdot(mj1m,mj2i);
  COM Mip=cdot(mj1i,mj2p);
  COM Mim=cdot(mj1i,mj2m);

  if (p2in.minus()>0) { // if negative incoming gluon
#if 1
    // add effect of q- g- -> q- g+
  {

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio2+a2Mmm/ratio2)+2./9.*(p2perp/conj(p2perp)*Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio2)*(conj(p2perp)/abs(p2perp)*Mmi*conj(Mmp)).real();
    term+=2./sqrt(ratio2)*(p2perp/abs(p2perp)*Mmi*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term*nonflipcolourmult1;
  }
#endif  
#if 1
  // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+
  {
    double term;
    term=(1.-1./9.)*(a2Mpp*ratio2+a2Mpm/ratio2)+2./9.*(p2perp/conj(p2perp)*Mpp*conj(Mpm)).real();
    term+=2.*abs2(Mpi);
    term+=2.*sqrt(ratio2)*(conj(p2perp)/abs(p2perp)*Mpi*conj(Mpp)).real();
    term+=2./sqrt(ratio2)*(p2perp/abs(p2perp)*Mpi*conj(Mpm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term*nonflipcolourmult1;
  }
#endif
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+

    double term;
    term=(1.-1./9.)*(a2Mmp*ratio2+a2Mmm/ratio2)+2./9.*(Mmp*conj(Mmm)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio2)*(Mmi*conj(Mmp)).real();
    term-=2./sqrt(ratio2)*(Mmi*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term*nonflipcolourmult1;
    // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+

    term=(1.-1./9.)*(a2Mpp*ratio2+a2Mpm/ratio2)+2./9.*(Mpp*conj(Mpm)).real();
    term+=2.*abs2(Mpi);
    term-=2.*sqrt(ratio2)*(Mpi*conj(Mpp)).real();
    term-=2./sqrt(ratio2)*(Mpi*conj(Mpm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term*nonflipcolourmult1;
  }

  // Flip current 1 and conserve helicity for current 2 
  if (p1in.minus()>0) { // if negative incoming gluon
  // add effect of c2- c1- -> c2- c1+
  {
    double term;
    term=(1.-1./9.)*(a2Mpm*ratio1+a2Mmm/ratio1)+2./9.*(p1perp/conj(p1perp)*Mpm*conj(Mmm)).real();
    term+=2.*abs2(Mim);
    term+=2.*sqrt(ratio1)*(conj(p1perp)/abs(p1perp)*Mim*conj(Mpm)).real();
    term+=2./sqrt(ratio1)*(p1perp/abs(p1perp)*Mim*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term*nonflipcolourmult2;
  }
  // add effect of c1+ c2+ -> c2+ c1- and c2+ c1- -> c2+ c1+
  {
    double term;
    term=(1.-1./9.)*(a2Mpp*ratio1+a2Mmp/ratio1)+2./9.*(p1perp/conj(p1perp)*Mpp*conj(Mmp)).real();
    term+=2.*abs2(Mip);
    term+=2.*sqrt(ratio1)*(conj(p1perp)/abs(p1perp)*Mip*conj(Mpp)).real();
    term+=2./sqrt(ratio1)*(p1perp/abs(p1perp)*Mip*conj(Mmp)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term*nonflipcolourmult2;
  }
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+
    double term;
    term=(1.-1./9.)*(a2Mpm*ratio1+a2Mmm/ratio1)+2./9.*(Mpm*conj(Mmm)).real();
    term+=2.*abs2(Mim);
    term-=2.*sqrt(ratio1)*(Mim*conj(Mpm)).real();
    term-=2./sqrt(ratio1)*(Mim*conj(Mmm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term*nonflipcolourmult2;
    // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+

    term=(1.-1./9.)*(a2Mpp*ratio1+a2Mmp/ratio1)+2./9.*(Mpp*conj(Mmp)).real();
    term+=2.*abs2(Mip);
    term-=2.*sqrt(ratio1)*(Mip*conj(Mpp)).real();
    term-=2./sqrt(ratio1)*(Mip*conj(Mmp)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    sst+=term*nonflipcolourmult2;

  }
#endif
   // std::cout <<"ratio: "<<sst/sstsave<<std::endl;
  // Ca*Ca=9
  return 9.*sst/(q1.m2()*q2.m2());

}

double MH2helper(current C1, current C2, current q1, current q2)
{
  COM M;
  COM temp1,temp2;
  // First the C1.q2 * C2.q1 - part
  temp1=cdot(C1,q2);
  temp2=cdot(C2,q1);
  M=temp1*temp2;
  
  // Then the C1.C2 * q1.q2
  temp1=cdot(C1,C2);
  temp2=cdot(q1,q2);
  M-=temp1*temp2;

  return (M*conj(M)).real();
}

COM cHdot(current C1, current C2, current q1, current q2)
{
  return cdot(C1,C2)*cdot(q1,q2)-cdot(C1,q2)*cdot(C2,q1);
}

double MH2qQ (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in, CLHEP::HepLorentzVector q1, CLHEP::HepLorentzVector q2)
{
//   CLHEP::HepLorentzVector q1=p1in-p1out;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current j1p,j1m,j2p,j2m,q1v,q2v;

  j (p1out,true,p1in,true,j1p);
  j (p1out,false,p1in,false,j1m);

  j (p2out,true,p2in,true,j2p);
  j (p2out,false,p2in,false,j2m);


  q1v[0]=q1.e();
  q1v[1]=q1.x();
  q1v[2]=q1.y();
  q1v[3]=q1.z();

  q2v[0]=q2.e();
  q2v[1]=q2.x();
  q2v[2]=q2.y();
  q2v[3]=q2.z();

  // std::cout << j1p[0]<< " "<<j1p[1]<<" "<<j1p[2]<< " "<<j1p[3]<<std::endl;
  // std::cout << j1m[0]<< " "<<j1m[1]<<" "<<j1m[2]<< " "<<j1m[3]<<std::endl;
  // std::cout << j2p[0]<< " "<<j2p[1]<<" "<<j2p[2]<< " "<<j2p[3]<<std::endl;
  // std::cout << j2m[0]<< " "<<j2m[1]<<" "<<j2m[2]<< " "<<j2m[3]<<std::endl;
  // std::cout << q1v[0]<< " "<<q1v[1]<<" "<<q1v[2]<< " "<<q1v[3]<<std::endl;
  // std::cout << q2v[0]<< " "<<q2v[1]<<" "<<q2v[2]<< " "<<q2v[3]<<std::endl;

  // first do plus on plus

  double MH2sum;
  MH2sum=MH2helper(j1p,j2p,q1v,q2v);
  // std::cout << "MH2sum : "<<MH2sum<<std::endl;
  // then do plus on minus
  MH2sum+=MH2helper(j1p,j2m,q1v,q2v);
  // etc...
  MH2sum+=MH2helper(j1m,j2p,q1v,q2v);
  MH2sum+=MH2helper(j1m,j2m,q1v,q2v);
  //  std::cout<<"qQ: "<<MH2sum<<"\n";
  return MH2sum/((p1in-p1out).m2()*(p2in-p2out).m2()*q1.m2()*q2.m2());
}

double MH2qQbar (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in, CLHEP::HepLorentzVector q1, CLHEP::HepLorentzVector q2)
{
//   CLHEP::HepLorentzVector q1=p1in-p1out;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current j1p,j1m,j2p,j2m,q1v,q2v;

  j (p1out,true,p1in,true,j1p);
  j (p1out,false,p1in,false,j1m);

  jio (p2in,true,p2out,true,j2p);
  jio (p2in,false,p2out,false,j2m);


  q1v[0]=q1.e();
  q1v[1]=q1.x();
  q1v[2]=q1.y();
  q1v[3]=q1.z();

  q2v[0]=q2.e();
  q2v[1]=q2.x();
  q2v[2]=q2.y();
  q2v[3]=q2.z();

  // first do plus on plus

  double MH2sum;
  MH2sum=MH2helper(j1p,j2p,q1v,q2v);
  // std::cout << "MH2sum : "<<MH2sum<<std::endl;
  // then do plus on minus
  MH2sum+=MH2helper(j1p,j2m,q1v,q2v);
  // etc...
  MH2sum+=MH2helper(j1m,j2p,q1v,q2v);
  MH2sum+=MH2helper(j1m,j2m,q1v,q2v);
  //  std::cout<<"qQbar: "<<MH2sum<<"\n";
  return MH2sum/((p1in-p1out).m2()*(p2in-p2out).m2()*q1.m2()*q2.m2());
}

double MH2qbarQ (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in, CLHEP::HepLorentzVector q1, CLHEP::HepLorentzVector q2)
{
//   CLHEP::HepLorentzVector q1=p1in-p1out;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current j1p,j1m,j2p,j2m,q1v,q2v;

  jio (p1in,true,p1out,true,j1p);
  jio (p1in,false,p1out,false,j1m);

  j (p2out,true,p2in,true,j2p);
  j (p2out,false,p2in,false,j2m);


  q1v[0]=q1.e();
  q1v[1]=q1.x();
  q1v[2]=q1.y();
  q1v[3]=q1.z();

  q2v[0]=q2.e();
  q2v[1]=q2.x();
  q2v[2]=q2.y();
  q2v[3]=q2.z();

  // first do plus on plus

  double MH2sum;
  MH2sum=MH2helper(j1p,j2p,q1v,q2v);
  // std::cout << "MH2sum : "<<MH2sum<<std::endl;
  // then do plus on minus
  MH2sum+=MH2helper(j1p,j2m,q1v,q2v);
  // etc...
  MH2sum+=MH2helper(j1m,j2p,q1v,q2v);
  MH2sum+=MH2helper(j1m,j2m,q1v,q2v);
  //  std::cout<<"qbarQ: "<<MH2sum<<"\n";
  return MH2sum/((p1in-p1out).m2()*(p2in-p2out).m2()*q1.m2()*q2.m2());
}

double MH2qbarQbar (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in, CLHEP::HepLorentzVector q1, CLHEP::HepLorentzVector q2)
{
//   CLHEP::HepLorentzVector q1=p1in-p1out;
//   CLHEP::HepLorentzVector q2=-(p2in-p2out);
  current j1p,j1m,j2p,j2m,q1v,q2v;

  jio (p1in,true,p1out,true,j1p);
  jio (p1in,false,p1out,false,j1m);

  jio (p2in,true,p2out,true,j2p);
  jio (p2in,false,p2out,false,j2m);


  q1v[0]=q1.e();
  q1v[1]=q1.x();
  q1v[2]=q1.y();
  q1v[3]=q1.z();

  q2v[0]=q2.e();
  q2v[1]=q2.x();
  q2v[2]=q2.y();
  q2v[3]=q2.z();

  // first do plus on plus

  double MH2sum;
  MH2sum=MH2helper(j1p,j2p,q1v,q2v);
  // std::cout << "MH2sum : "<<MH2sum<<std::endl;
  // then do plus on minus
  MH2sum+=MH2helper(j1p,j2m,q1v,q2v);
  // etc...
  MH2sum+=MH2helper(j1m,j2p,q1v,q2v);
  MH2sum+=MH2helper(j1m,j2m,q1v,q2v);
  //  std::cout<<"qbarQbar: "<<MH2sum<<"\n";
  return MH2sum/((p1in-p1out).m2()*(p2in-p2out).m2()*q1.m2()*q2.m2());
}

double MH2qg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in, CLHEP::HepLorentzVector q1, CLHEP::HepLorentzVector q2)
// q~p1 g~p2 (i.e. ALWAYS p1 for quark, p2 for gluon)
// should be called with q1 meant to be contracted with p2 in first part of vertex 
// (i.e. if g is backward, q1 is forward)
{
  current j1p,j1m,j2p,j2m,q1v,q2v;
  
  j (p1out,true,p1in,true,j1p);
  j (p1out,false,p1in,false,j1m);
  
  j (p2out,true,p2in,true,j2p);
  j (p2out,false,p2in,false,j2m);
  
  q1v[0]=q1.e();
  q1v[1]=q1.x();
  q1v[2]=q1.y();
  q1v[3]=q1.z();
  
  q2v[0]=q2.e();
  q2v[1]=q2.x();
  q2v[2]=q2.y();
  q2v[3]=q2.z();
  
  // First, calculate the non-flipping amplitudes:
  
  COM amp,amm,apm,app;
  app=cHdot(j1p,j2p,q1v,q2v);
  apm=cHdot(j1p,j2m,q1v,q2v);
  amp=cHdot(j1m,j2p,q1v,q2v);
  amm=cHdot(j1m,j2m,q1v,q2v);

  double MH2sum,a2mp,a2mm,a2pm,a2pp;
  MH2sum=a2pp=(app*conj(app)).real();
  // std::cout << "MH2sum : "<<MH2sum<<std::endl;
  // then do plus on minus
  MH2sum+=a2mm=(amm*conj(amm)).real();
  // etc...
  MH2sum+=a2pm=(apm*conj(apm)).real();
  MH2sum+=a2mp=(amp*conj(amp)).real();

  double ratio; // p2-/pb- in the notes
  // if (p2in.plus()>0) // if the gluon is the positive
  if (p2in.pz()>0) // if the gluon is the positive
    ratio=p2out.plus()/p2in.plus();
  else // the gluon is the negative
    ratio=p2out.minus()/p2in.minus();

  double nonflipcolourmult=(1.-1./9.)/2.*(ratio+1./ratio)+1./9.;
  MH2sum*=nonflipcolourmult;
  
  // Now, calculate the flipping amplitudes
#if 0
    COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    current mj2i;

    mj2i[0]=(p2in+p2out).e();
    mj2i[1]=(p2in+p2out).x();
    mj2i[2]=(p2in+p2out).y();
    mj2i[3]=(p2in+p2out).z();
  if (p2in.minus()>0) { // if negative incoming gluon
#if 1
    // add effect of q- g- -> q- g+
  {

    // mj1m.mj2i 

    COM Mmi=cHdot(j1m,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2mp*ratio+a2mm/ratio)+2./9.*(p2perp/conj(p2perp)*amp*conj(amm)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(amp)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(amm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term;
  }
  // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+
  {

    COM Mpi=cHdot(j1p,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2pp*ratio+a2pm/ratio)+2./9.*(p2perp/conj(p2perp)*app*conj(apm)).real();
    term+=2.*abs2(Mpi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mpi*conj(app)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mpi*conj(apm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term;
  }
#endif  
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+

    // mj1m.mj2i 

    COM Mmi=cHdot(j1m,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2mp*ratio+a2mm/ratio)+2./9.*(amp*conj(amm)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio)*(Mmi*conj(amp)).real();
    term-=2./sqrt(ratio)*(Mmi*conj(amm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term;

    COM Mpi=cHdot(j1p,mj2i,q1v,q2v);

    term=(1.-1./9.)*(a2pp*ratio+a2pm/ratio)+2./9.*(app*conj(apm)).real();
    term+=2.*abs2(Mpi);
    term-=2.*sqrt(ratio)*(Mpi*conj(app)).real();
    term-=2./sqrt(ratio)*(Mpi*conj(apm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term;
  }


#endif
  
  return MH2sum/((p1in-p1out).m2()*(p2in-p2out).m2()*q1.m2()*q2.m2());
  
}

double MH2qbarg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in, CLHEP::HepLorentzVector q1, CLHEP::HepLorentzVector q2)
// qbar~p1 g~p2 (i.e. ALWAYS p1 for anti-quark, p2 for gluon)
// should be called with q1 meant to be contracted with p2 in first part of vertex 
// (i.e. if g is backward, q1 is forward)
{
  current j1p,j1m,j2p,j2m,q1v,q2v;
  
  jio (p1in,true,p1out,true,j1p);
  jio (p1in,false,p1out,false,j1m);
  
  j (p2out,true,p2in,true,j2p);
  j (p2out,false,p2in,false,j2m);
  
  q1v[0]=q1.e();
  q1v[1]=q1.x();
  q1v[2]=q1.y();
  q1v[3]=q1.z();
  
  q2v[0]=q2.e();
  q2v[1]=q2.x();
  q2v[2]=q2.y();
  q2v[3]=q2.z();
  
  // First, calculate the non-flipping amplitudes:
  
  COM amp,amm,apm,app;
  app=cHdot(j1p,j2p,q1v,q2v);
  apm=cHdot(j1p,j2m,q1v,q2v);
  amp=cHdot(j1m,j2p,q1v,q2v);
  amm=cHdot(j1m,j2m,q1v,q2v);

  double MH2sum,a2mp,a2mm,a2pm,a2pp;
  MH2sum=a2pp=(app*conj(app)).real();
  // std::cout << "MH2sum : "<<MH2sum<<std::endl;
  // then do plus on minus
  MH2sum+=a2mm=(amm*conj(amm)).real();
  // etc...
  MH2sum+=a2pm=(apm*conj(apm)).real();
  MH2sum+=a2mp=(amp*conj(amp)).real();

  double ratio; // p2-/pb- in the notes
  // if (p2in.plus()>0) // if the gluon is the positive
  if (p2in.pz()>0) // if the gluon is the positive
    ratio=p2out.plus()/p2in.plus();
  else // the gluon is the negative
    ratio=p2out.minus()/p2in.minus();

  double nonflipcolourmult=(1.-1./9.)/2.*(ratio+1./ratio)+1./9.;
  MH2sum*=nonflipcolourmult;
  
  // Now, calculate the flipping amplitudes
#if 0
    COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    current mj2i;

    mj2i[0]=(p2in+p2out).e();
    mj2i[1]=(p2in+p2out).x();
    mj2i[2]=(p2in+p2out).y();
    mj2i[3]=(p2in+p2out).z();
  if (p2in.minus()>0) { // if negative incoming gluon
#if 1
    // add effect of q- g- -> q- g+
  {

    // mj1m.mj2i 

    COM Mmi=cHdot(j1m,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2mp*ratio+a2mm/ratio)+2./9.*(p2perp/conj(p2perp)*amp*conj(amm)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mmi*conj(amp)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mmi*conj(amm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term;
  }
  // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+
  {

    COM Mpi=cHdot(j1p,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2pp*ratio+a2pm/ratio)+2./9.*(p2perp/conj(p2perp)*app*conj(apm)).real();
    term+=2.*abs2(Mpi);
    term+=2.*sqrt(ratio)*(conj(p2perp)/abs(p2perp)*Mpi*conj(app)).real();
    term+=2./sqrt(ratio)*(p2perp/abs(p2perp)*Mpi*conj(apm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term;
  }
#endif  
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+

    // mj1m.mj2i 

    COM Mmi=cHdot(j1m,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2mp*ratio+a2mm/ratio)+2./9.*(amp*conj(amm)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio)*(Mmi*conj(amp)).real();
    term-=2./sqrt(ratio)*(Mmi*conj(amm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term;

    COM Mpi=cHdot(j1p,mj2i,q1v,q2v);

    term=(1.-1./9.)*(a2pp*ratio+a2pm/ratio)+2./9.*(app*conj(apm)).real();
    term+=2.*abs2(Mpi);
    term-=2.*sqrt(ratio)*(Mpi*conj(app)).real();
    term-=2./sqrt(ratio)*(Mpi*conj(apm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term;
  }


#endif
  
  return MH2sum/((p1in-p1out).m2()*(p2in-p2out).m2()*q1.m2()*q2.m2());
  
}

double MH2gg (CLHEP::HepLorentzVector p1out, CLHEP::HepLorentzVector p1in, CLHEP::HepLorentzVector p2out, CLHEP::HepLorentzVector p2in, CLHEP::HepLorentzVector q1, CLHEP::HepLorentzVector q2)
// g~p1 g~p2
// should be called with q1 meant to be contracted with p2 in first part of vertex 
// (i.e. if g is backward, q1 is forward)
{
  current j1p,j1m,j2p,j2m,q1v,q2v;
  
  j (p1out,true,p1in,true,j1p);
  j (p1out,false,p1in,false,j1m);
  
  j (p2out,true,p2in,true,j2p);
  j (p2out,false,p2in,false,j2m);
  
  q1v[0]=q1.e();
  q1v[1]=q1.x();
  q1v[2]=q1.y();
  q1v[3]=q1.z();
  
  q2v[0]=q2.e();
  q2v[1]=q2.x();
  q2v[2]=q2.y();
  q2v[3]=q2.z();
  
  // First, calculate the non-flipping amplitudes:
  
  COM amp,amm,apm,app;
  app=cHdot(j1p,j2p,q1v,q2v);
  apm=cHdot(j1p,j2m,q1v,q2v);
  amp=cHdot(j1m,j2p,q1v,q2v);
  amm=cHdot(j1m,j2m,q1v,q2v);

  double MH2sum,a2mp,a2mm,a2pm,a2pp;
  MH2sum=a2pp=(app*conj(app)).real();
  // std::cout << "MH2sum : "<<MH2sum<<std::endl;
  // then do plus on minus
  MH2sum+=a2mm=(amm*conj(amm)).real();
  // etc...
  MH2sum+=a2pm=(apm*conj(apm)).real();
  MH2sum+=a2mp=(amp*conj(amp)).real();

  double ratio1; // p1-/pa- in the notes
  // if (p1in.plus()>0) // if the gluon is the positive
  if (p1in.pz()>0.) // if the gluon is the positive
    ratio1=p1out.plus()/p1in.plus();
  else // the gluon is the negative
    ratio1=p1out.minus()/p1in.minus();

  double nonflipcolourmult1=(1.-1./9.)/2.*(ratio1+1./ratio1)+1./9.;

  double ratio2; // p2-/pb- in the notes
  // if (p2in.plus()>0) // if the gluon is the positive
  if (p2in.pz()>0.) // if the gluon is the positive
    ratio2=p2out.plus()/p2in.plus();
  else // the gluon is the negative
    ratio2=p2out.minus()/p2in.minus();

  double nonflipcolourmult2=(1.-1./9.)/2.*(ratio2+1./ratio2)+1./9.;
  MH2sum*=nonflipcolourmult1*nonflipcolourmult2;
  
  // Now, calculate the flipping amplitudes
#if 0
    COM p1perp=p1out.x()+COM(0,1)*p1out.y();
    COM p2perp=p2out.x()+COM(0,1)*p2out.y();
    current mj1i,mj2i;

    mj1i[0]=(p1in+p1out).e();
    mj1i[1]=(p1in+p1out).x();
    mj1i[2]=(p1in+p1out).y();
    mj1i[3]=(p1in+p1out).z();

    mj2i[0]=(p2in+p2out).e();
    mj2i[1]=(p2in+p2out).x();
    mj2i[2]=(p2in+p2out).y();
    mj2i[3]=(p2in+p2out).z();
  if (p2in.minus()>0) { // if negative incoming gluon
#if 1
    // add effect of q- g- -> q- g+
  {

    // mj1m.mj2i 

    COM Mmi=cHdot(j1m,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2mp*ratio2+a2mm/ratio2)+2./9.*(p2perp/conj(p2perp)*amp*conj(amm)).real();
    term+=2.*abs2(Mmi);
    term+=2.*sqrt(ratio2)*(conj(p2perp)/abs(p2perp)*Mmi*conj(amp)).real();
    term+=2./sqrt(ratio2)*(p2perp/abs(p2perp)*Mmi*conj(amm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term*nonflipcolourmult1;
  }
  // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+
  {

    COM Mpi=cHdot(j1p,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2pp*ratio2+a2pm/ratio2)+2./9.*(p2perp/conj(p2perp)*app*conj(apm)).real();
    term+=2.*abs2(Mpi);
    term+=2.*sqrt(ratio2)*(conj(p2perp)/abs(p2perp)*Mpi*conj(app)).real();
    term+=2./sqrt(ratio2)*(p2perp/abs(p2perp)*Mpi*conj(apm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term*nonflipcolourmult1;
  }
#endif  
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+

    // mj1m.mj2i 

    COM Mmi=cHdot(j1m,mj2i,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2mp*ratio2+a2mm/ratio2)+2./9.*(amp*conj(amm)).real();
    term+=2.*abs2(Mmi);
    term-=2.*sqrt(ratio2)*(Mmi*conj(amp)).real();
    term-=2./sqrt(ratio2)*(Mmi*conj(amm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term*nonflipcolourmult1;

    COM Mpi=cHdot(j1p,mj2i,q1v,q2v);

    term=(1.-1./9.)*(a2pp*ratio2+a2pm/ratio2)+2./9.*(app*conj(apm)).real();
    term+=2.*abs2(Mpi);
    term-=2.*sqrt(ratio2)*(Mpi*conj(app)).real();
    term-=2./sqrt(ratio2)*(Mpi*conj(apm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term*nonflipcolourmult1;
  }
#if 1
  // Flip current 1 and conserve helicity for current 2 
  if (p1in.minus()>0) { // if negative incoming gluon
  // add effect of c2- c1- -> c2- c1+
  {

    // mj2m.mj1i 

    COM Mim=cHdot(mj1i,j2m,q1v,q2v); // need to be in the right order. 

    double term;
    term=(1.-1./9.)*(a2pm*ratio1+a2mm/ratio1)+2./9.*(p1perp/conj(p1perp)*apm*conj(amm)).real();
    term+=2.*abs2(Mim);
    term+=2.*sqrt(ratio1)*(conj(p1perp)/abs(p1perp)*Mim*conj(apm)).real();
    term+=2./sqrt(ratio1)*(p1perp/abs(p1perp)*Mim*conj(amm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term*nonflipcolourmult2;
  }
  // add effect of c1+ c2+ -> c2+ c1- and c2+ c1- -> c2+ c1+
  {
    COM Mip=cHdot(mj1i,j2p,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2pp*ratio1+a2mp/ratio1)+2./9.*(p1perp/conj(p1perp)*app*conj(amp)).real();
    term+=2.*abs2(Mip);
    term+=2.*sqrt(ratio1)*(conj(p1perp)/abs(p1perp)*Mip*conj(app)).real();
    term+=2./sqrt(ratio1)*(p1perp/abs(p1perp)*Mip*conj(amp)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term*nonflipcolourmult2;
  }
  } else { // positive incoming gluon
    // std::cout << "Don't do it!\n";
    // add effect of q- g- -> q- g+

    // mj1m.mj2i 

    COM Mim=cHdot(mj1i,j2m,q1v,q2v);

    double term;
    term=(1.-1./9.)*(a2pm*ratio1+a2mm/ratio1)+2./9.*(apm*conj(amm)).real();
    term+=2.*abs2(Mim);
    term-=2.*sqrt(ratio1)*(Mim*conj(apm)).real();
    term-=2./sqrt(ratio1)*(Mim*conj(amm)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term*nonflipcolourmult2;
    // add effect of q+ g+ -> q+ g- and q+ g- -> q+ g+
    // mj1p.mj2i
    COM Mip=cHdot(mj1i,j2p,q1v,q2v);

    term=(1.-1./9.)*(a2pp*ratio1+a2mp/ratio1)+2./9.*(app*conj(amp)).real();
    term+=2.*abs2(Mip);
    term-=2.*sqrt(ratio1)*(Mip*conj(app)).real();
    term-=2./sqrt(ratio1)*(Mip*conj(amp)).real();
    
    // we get the same contribution from flipping the gluon helicity from g^+ -> g^- 
    // so don't first divide and then multiply by two
    // term/=2.;
    MH2sum+=term*nonflipcolourmult2;
  }
#endif
#endif

  
  return MH2sum/((p1in-p1out).m2()*(p2in-p2out).m2()*q1.m2()*q2.m2());
  
}
